#include "data_rtm_3d.h"
#include <math.h>

data_rtm_3d::data_rtm_3d(char *tg,param_func *par){
   tag_init(tg);
   //Should do sanity checks here

  axis a=get_axis(1);
  max_time=a.o+a.d*(a.n-1);
  max_time=max_time;
  //max_time=.2;
  dt=a.d;
  nt=a.n;
   rec_locs=0; data=0;
   dsamp=dt;
   sz=par->get_float("rec_depth",0.);
rec_depth=0.;
}
int data_rtm_3d::get_points(){
  return get_axis(2).n*get_axis(3).n;
}

int data_rtm_3d::get_points1(){
  return get_axis(2).n;
}

int data_rtm_3d::get_points2(){
  return get_axis(3).n;
}


void data_rtm_3d::add_data(int ishot, hypercube_float *dat){
//Ok. This routine has not been changed, but it is not used in the 2d version
fprintf(stderr,"ADD DATA\n");
  sseek_block(myf->tagit.c_str(),get_axis(2).n*ishot,get_axis(1).n*4,0);
  hypercube_float *tmp=(hypercube_float*)dat->clone_zero();
  sreed(myf->tagit.c_str(),tmp->vals,get_axis(1).n*get_axis(2).n*4);
  for(int i=0; i < (int) tmp->get_n123(); i++) tmp->vals[i]+=dat->vals[i];
  sseek_block(myf->tagit.c_str(),get_axis(2).n*ishot,get_axis(1).n*4,0);
  srite(myf->tagit.c_str(),tmp->vals,get_axis(1).n*get_axis(2).n*4);
  delete tmp;

}

void data_rtm_3d::get_source_func(hypercube_float *domain, int ishot, 
float *s_z, float *s_x, float *s_y, int nsinc,  int nts,hypercube_float *time){
  axis a1=domain->get_axis(1);
  axis a2=domain->get_axis(2);
  axis a3=domain->get_axis(3);
  axis at=get_axis(1);
  sseek_block(myf->tagit.c_str(),get_axis(3).n*get_axis(2).n*ishot,get_axis(1).n*4,0);
  sreed(myf->tagit.c_str(),time->vals,get_axis(1).n*get_axis(2).n*get_axis(3).n*4);

 // float sx=get_axis(4).o+get_axis(4).d*ishot;
 // float sy=get_axis(5).o+get_axis(5).d*ishot;
/*
fprintf(stderr,"Sxy deets %d %d %f %f\n",get_axis(4).n,get_axis(5).n,sx,sy);
fprintf(stderr,"Locs deets %d %d ... sz=%f %f %f\n",get_axis(2).n,get_axis(3).n,sz,a1.o,a1.d);
fprintf(stderr,"S_z deets sz=%f o=%f d=%f \n",sz,a1.o, a1.d);
fprintf(stderr,"S_x deets sx=%f n=%d d=%f o=%f o2=%f d2=%f \n",sx,get_axis(2).n, get_axis(2).d, get_axis(2).o,a2.o,a2.d);
fprintf(stderr,"S_y deets sx=%f n=%d d=%f o=%f o2=%f d2=%f \n",sy,get_axis(3).n, get_axis(3).d, get_axis(3).o,a3.o,a3.d);
fprintf(stderr,"Domain deets n=%d d=%f o=%f n=%d d=%f o=%f n=%d d=%f o=%f \n",a1.n,a1.d,a1.o,a2.n,a2.d,a2.o,a3.n,a3.d,a3.o);*/
  int i=0;

  float *sz1=new float[get_axis(4).n*get_axis(5).n];
  float *sx1=new float[get_axis(4).n*get_axis(5).n];
  float *sy1=new float[get_axis(4).n*get_axis(5).n];

  for(int i1=0; i1 < get_axis(4).n; i1++){
    for(int i2=0; i2 < get_axis(5).n; i2++,i++){
      sz1[i]=sz;
      sx1[i]=get_axis(4).o+get_axis(4).d*i1;
      sy1[i]=get_axis(5).o+get_axis(5).d*i2;
//fprintf(stderr,"src stuff %f %f %f\n",sz,get_axis(4).o+get_axis(4).d*i1,get_axis(5).o+get_axis(5).d*i2);
    }
  }
fprintf(stderr,"Current receiver depth %f %f %f \n",sz1[ishot],sx1[ishot],sy1[ishot]);
float a2o=sx1[ishot];
float a3o=sy1[ishot];
  i=0;
  for(int i3=0; i3< get_axis(3).n; i3++){

    for(int i2=0; i2< get_axis(2).n; i2++, i++){
      s_z[i]=(sz1[ishot]-a1.o)/a1.d;
      s_x[i]=(sx1[ishot]+get_axis(2).o+get_axis(2).d*i2-a2o)/a2.d;
      s_y[i]=(sy1[ishot]+get_axis(3).o+get_axis(3).d*i3-a3o)/a3.d;

    }
  }

  sseek(myf->tagit.c_str(),0,0);

}


