#include "gpu_finite_3d.h"
#include <stdlib.h>
#include "sep3d.h"
#include "seplib.h"  
#include "cudaErrors.cu"
#include "wave_fkernel.3d8o.cu"
#include "cutil_inline.h"
#include "cutil_math.h"


double dd1,dd2,dd3;
extern "C" __global__ void extract_kernel(int it, float *extract_gpu,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i<nextract_gpu){
	  extract_gpu[it*nextract_gpu+i]=p[extract_geom0[i]];
	}
}

extern "C" __global__ void new_src_inject_kernel(int it, int isinc,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
                p[srcgeom_gpu0[i]]+=dir_gpu*(
        sinc_s_table[isinc*nsinc_gpu]*source_gpu0[ntrace_gpu*i+it]+
        sinc_s_table[isinc*nsinc_gpu+1]*source_gpu0[ntrace_gpu*i+it+1]+
	sinc_s_table[isinc*nsinc_gpu+2]*source_gpu0[ntrace_gpu*i+it+2]+
        sinc_s_table[isinc*nsinc_gpu+3]*source_gpu0[ntrace_gpu*i+it+3]+
	sinc_s_table[isinc*nsinc_gpu+4]*source_gpu0[ntrace_gpu*i+it+4]+
        sinc_s_table[isinc*nsinc_gpu+5]*source_gpu0[ntrace_gpu*i+it+5]+
        sinc_s_table[isinc*nsinc_gpu+6]*source_gpu0[ntrace_gpu*i+it+6]+
        sinc_s_table[isinc*nsinc_gpu+7]*source_gpu0[ntrace_gpu*i+it+7]);


}
extern "C" __global__ void new_data_inject_kernel(int it, int isinc,float *p){
	int nblocksz=(n1gpu-2*FAT)/BLOCKZ_SIZE;
	int yblock=(blockIdx.x/nblocksz);
	int y0=FAT+yblock*BLOCKY_SIZE;
	int il=FAT+threadIdx.x; 				// thread-local z coordinate
	int jl=FAT+threadIdx.y;					// thread-local x coordinate
	int ig=(blockIdx.x-yblock*nblocksz)*blockDim.x+il; 	// global z coordinates
	int jg=blockIdx.y*blockDim.y+jl; 	 		// global x coordinates
	int j=blockIdx.y*blockDim.y+threadIdx.y;
	int k=blockIdx.x*blockDim.x+threadIdx.x;
	for(int yy=0; yy<BLOCKY_SIZE; yy++){
//	int i=jg+n2gpu*(y0+yy);
//	int i=ig+jg*n1gpu;
	int i=ig+n1gpu*jg;
//int i=k;
	if(i< nrec_gpu){
	    p[datageom_gpu0[i]]+=
            /*sinc_d_table[isinc*nsinc_gpu]*/data_gpu0[ntrace_gpu*i+it]/* +
	    sinc_d_table[isinc*nsinc_gpu+1]*data_gpu0[ntrace_gpu*i+it+1]+
	    sinc_d_table[isinc*nsinc_gpu+2]*data_gpu0[ntrace_gpu*i+it+2]+
	    sinc_d_table[isinc*nsinc_gpu+3]*data_gpu0[ntrace_gpu*i+it+3]+
	    sinc_d_table[isinc*nsinc_gpu+4]*data_gpu0[ntrace_gpu*i+it+4]+
	    sinc_d_table[isinc*nsinc_gpu+5]*data_gpu0[ntrace_gpu*i+it+5]+
	    sinc_d_table[isinc*nsinc_gpu+6]*data_gpu0[ntrace_gpu*i+it+6]+
	    sinc_d_table[isinc*nsinc_gpu+7]*data_gpu0[ntrace_gpu*i+it+7]*/;
	}

  }
}
extern "C" __global__ void new_data_extract_kernel(int it, int isinc,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i< nrec_gpu){
	
	  data_gpu0[ntrace_gpu*i+it+0]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+0];
	  data_gpu0[ntrace_gpu*i+it+1]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+1];
	  data_gpu0[ntrace_gpu*i+it+2]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+2];
	  data_gpu0[ntrace_gpu*i+it+3]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+3];
	  data_gpu0[ntrace_gpu*i+it+4]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+4];
	  data_gpu0[ntrace_gpu*i+it+5]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+5];
	  data_gpu0[ntrace_gpu*i+it+6]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+6];
	  data_gpu0[ntrace_gpu*i+it+7]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+7];
	  
  }
}
extern "C" __global__ void img_kernel( float* img, float*dat, float*src){/*ok. now this is just pure guesswork!*/
	int nblocksz=(n1gpu-2*FAT)/BLOCKZ_SIZE;
	int yblock=(blockIdx.x/nblocksz);
	int y0=FAT+yblock*BLOCKY_SIZE;
	int il=FAT+threadIdx.x; 				// thread-local z coordinate
	int jl=FAT+threadIdx.y;					// thread-local x coordinate
	int ig=(blockIdx.x-yblock*nblocksz)*blockDim.x+il; 	// global z coordinates
	int jg=blockIdx.y*blockDim.y+jl; 	 		// global x coordinates

	for(int yy=0; yy<BLOCKY_SIZE; yy++){
	  img[dloc(ig,jg,y0+yy)]+=.000001*dat[dloc(ig,jg,y0+yy)]*src[dloc(ig,jg,y0+yy)];
	}
}

extern "C" __global__ void slice_kernel(float *p, float *s)
{

        int nblocksz=(n1gpu-2*FAT)/BLOCKZ_SIZE;
	int yblock=(blockIdx.x/nblocksz);
	int y0=yblock*BLOCKY_SIZE;
	int xl=FAT+threadIdx.y; 		// local  xdir
	int xg=blockIdx.y*blockDim.y+xl; 	// global xdir

	for(int yy=0; yy<BLOCKY_SIZE; yy++){
	  s[dloc2(xg,y0+yy)]=p[dloc(FAT,xg,y0+yy)];
	}

}

extern "C" __global__ void img_add_kernel( float* img, float*rec_field, float *src_field){//as above, added 
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	int j=blockIdx.y*blockDim.y+threadIdx.y;
        int k=blockIdx.z*blockDim.z+threadIdx.z;
	rec_field[dloc(i,j,k)]+=.000001*src_field[dloc(i,j,k)]*img[dloc(i,j,k)];
}



void setup_cuda(int device, int argc, char **argv){
  CUT_DEVICE_INIT(argc, argv);
  fprintf(stderr,"    SETTING DEVICE %d \n",device);
  cudaSetDevice(device);
}

void source_prop(int n1, int n2, int n3, bool damp, bool get_last, float *p0, float *p1, float *tmp, int jt,
int npts,int nt,int nextract, int *extract_pts, float *extracted,int jwave, char *tag){
fprintf(stderr,"    GPU source prop %d,%d,%f,%f,%d, %d,%d,%d,%d,%c\n", n1,n2,*p0,*p1,jt,npts,nt,nextract,jwave,*tag);
  //ALLOCATE GPU MEMORY
  float *ptemp;
  float *p0_gpu,*p1_gpu, *s_gpu;
  cuda_call(cudaMalloc((void**) &p0_gpu,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &p1_gpu,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &s_gpu,n2*n3*sizeof(float)));

  
  //ZERO GPU MEMORY
  cuda_call(cudaMemset(p0_gpu, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(p1_gpu, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(s_gpu,  0, n2*n3*sizeof(float)));


  
  //SET SOURCE PROP DIRECTION
  int dir=1;
	cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));
  //WHEN CONSTRUCTING RECEIVER GATHERS
  int nt_loc=(nt-1)/jt+1;
  if(nextract!=0){
    //ALLOCATE GPU MEMORY FOR EXTRACT
    cuda_call(cudaMalloc((void**) &extract_gpu,nextract*nt_loc*sizeof(float)));
    cuda_call(cudaMalloc((void**) &extract_geom,nextract*sizeof(float)));
    
    //COPY DESIRED POSITIONS TO GPU
    cuda_call(cudaMemcpyToSymbol(nextract_gpu,&nextract,sizeof(int)));
    cuda_call(cudaMemcpy(extract_geom, extract_pts, nextract*sizeof(float),cudaMemcpyHostToDevice));
    cuda_call(cudaMemcpyToSymbol(extract_geom0, &extract_geom, sizeof(int)));
  }
  
  //BUFFER TO STORE WAVEFIELD
  float *temp;
  if(jwave>0) temp=(float*)malloc(sizeof(float)*n1*n2*n3);

  //GPU BLOCKS
  int nblocksz=(n1-2*FAT)/BLOCKZ_SIZE;
  int nblocksx=(n2-2*FAT)/BLOCKX_SIZE; /* remainder points will be ignored */
  int nblocksy=(n3-2*FAT)/BLOCKY_SIZE; /* remainder points will be ignored */
  dim3 dimGrid(nblocksz*nblocksy,nblocksx);
  dim3 dimBlock(BLOCKZ_SIZE, BLOCKX_SIZE);

nt=920;
  for(int it=0; it<nt; it++){
    //POINTERS INTO DATA ARRAY AND SINC ARRAY
    int id=it/jt;
    int i=it-id*jt;

    //FORWARD PROPAGATE SOURCE
    kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(p0_gpu, p1_gpu, p0_gpu));
    kernel_exec(new_src_inject_kernel<<<1,npts>>>(id /*size of sinc*/,i, p0_gpu));

    if(it%8==0){
//	kernel_exec(slice_kernel<<<dimGrid, dimBlock>>>(p1_gpu,s_gpu));
//	cuda_call(cudaMemcpy(&tmp[(it/8)*n2*n3], s_gpu, n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
    }

    ptemp=p0_gpu; p0_gpu=p1_gpu;p1_gpu=ptemp;
  }

  if(get_last){
    cuda_call(cudaMemcpy(p0, p0_gpu, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
    cuda_call(cudaMemcpy(p1, p1_gpu, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
  }

  //FREE GPU MEMORY ALL OPTIONS
  cuda_call( cudaFree(source_gpu) );
  cuda_call( cudaFree(srcgeom_gpu));
  cuda_call( cudaFree(p0_gpu));
  cuda_call( cudaFree(p1_gpu));
  cuda_call( cudaFree(s_gpu));
}



void rtm_adjoint(int n1, int n2, int n3, int jt, float *p0_s_cpu, float *p1_s_cpu, float *img, int npts_src, int npts,int nt){
   //MEMORY ALLOCATION
   float *src_p0,*src_p1,*data_p0,*data_p1,*img_gpu;
   fprintf(stderr,"    Adjoint routine \n");
   fprintf(stderr,"    Size per wavefield %d %d %d %d %dmb\n", n1, n2, n3, n1*n2*n3, (n1)*(n2)*(n3)*sizeof(float)/1000000);
   cuda_call(cudaMalloc((void**) &src_p0, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMalloc((void**) &src_p1, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMalloc((void**) &data_p0, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMalloc((void**) &data_p1, n1*n2*n3*sizeof(float))); 
   cuda_call(cudaMalloc((void**) &img_gpu, n1*n2*n3*sizeof(float)));
   cuda_call(cudaMemcpy(src_p0, p0_s_cpu, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpy(src_p1, p1_s_cpu, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));
  
   //ZERO BUFFERS
   cuda_call(cudaMemset(data_p0, 0,n1*n2*n3*sizeof(float)));
   cuda_call(cudaMemset(data_p1, 0,n1*n2*n3*sizeof(float)));
   cuda_call(cudaMemset(img_gpu, 0,n1*n2*n3*sizeof(float)));

   //SET SOURCE DIRECTION FOR REVERSE PROPAGATION
   int dir=-1;
   cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));

   //COPY SOURCE BUFFER FOR REVERSE PROPAGATION
   cuda_call(cudaMemcpy(src_p0, p0_s_cpu, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpy(src_p1, p1_s_cpu, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));


   //BLOCKS FOR THE GPU
   int nblocksz=(n1-2*FAT)/BLOCKZ_SIZE;
   int nblocksx=(n2-2*FAT)/BLOCKX_SIZE; /* remainder points will be ignored */
   int nblocksy=(n3-2*FAT)/BLOCKY_SIZE; /* remainder points will be ignored */
   dim3 dimGrid(nblocksz*nblocksy,nblocksx);
   dim3 dimBlock(BLOCKZ_SIZE, BLOCKX_SIZE);



   //IMAGING VS PROPAGATION STEPS FOR SOURCE SUBTRACT
   int id_s=(nt+1)/jt;     //SAMPLING IN DATA POINTER
   int i_s=(nt+1)-id_s*jt; //OFFSET FOR DATA POINTER

   //SUBTRACT OFF LAST SOURCE
   kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id_s /*size of sinc*/,i_s, src_p0));
   cuda_call(cudaMemcpy(p0_s_cpu, src_p0, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
nt=920;
   for(int it=nt-1; it >=0 ;it--){


     int id=it/jt;  //POINTER INTO DATA SAMPLING
     int i=it-id*jt;//OFFSET FROM DATA SAMPLING
     id_s=(it+1)/jt;//SAMPLING INTO SOURCE FIELD???
     i_s=it+1-id_s*jt;//OFFSET FROM SOURCE FIELD

     // kernel_exec(wave_kernel_damp<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0));

     //REVERSE PROPAGATE DATA
     kernel_exec(wave_kernel2<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0));//back!
     kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(nblocksz,data_p0,data_p1));

     //REVERSE PROPAGATE SOURCE
     kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(src_p0,src_p1,src_p0)); //bring back in!

     //SUBTRACT OFF SOURCE 
     kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id_s /*size of sinc*/,i_s, src_p1)); //bring back in!!

     //INJECT DATA AT CURRENT TIME SAMPLE
     kernel_exec(new_data_inject_kernel<<<(int)ceilf(1.*npts/100.),100>>>(id ,i, data_p0)); //brig back in!



     if(i==0){ //WE ARE AT IMAGING TIME
       //IMAGE AT CURRENT LOCATION
   //    kernel_exec(img_kernel<<<dimGrid, dimBlock>>>(img_gpu,data_p0,src_p0));//bring back!
     }

if(it==(nt-1)){

	cuda_call(cudaMemcpy(&img[n1*n2*n3], src_p0, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
}

     if((nt-it+50)%50==0){ //WE ARE AT IMAGING TIME
       //IMAGE AT CURRENT LOCATION

	cuda_call(cudaMemcpy(&img[((nt-it+50)/50)*n1*n2*n3], src_p0, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
     }

     //REVERSE FIELD POINTERS
     float *ptemp=data_p1; data_p1=data_p0; data_p0=ptemp;
     float  *ptemp2=src_p1; src_p1=src_p0; src_p0=ptemp2;
   }
  //COPY IMAGE TO CPU
//  cuda_call(cudaMemcpy(img, img_gpu, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost)); //bring back!
  
  //FREE GPU MEMORY
  cuda_call( cudaFree(datageom_gpu));
  cuda_call( cudaFree(data_p0));
  cuda_call( cudaFree(data_gpu));
  cuda_call( cudaFree(img_gpu) );
  cuda_call( cudaFree(source_gpu) );
  cuda_call( cudaFree(srcgeom_gpu));
  cuda_call( cudaFree(data_p1));
  cuda_call( cudaFree(src_p0));
  cuda_call( cudaFree(src_p1));
}


void wavefield_debugging(char *file, char *tag,int n1, int n2, int n3, float *field){
  float *temp=(float*)malloc(sizeof(float)*n1*n2*n3); 
  cuda_call(cudaMemcpy(temp,field, n1*n2*n3*sizeof(float), cudaMemcpyDeviceToHost));
//  fprintf(stderr,"DEBUG %s %f \n",tag,temp[168051]);
  srite(file,temp,n1*n2*n3*4);
  
  free(temp);
}
void transfer_sinc_table_s(int nsinc, int ns,  float **tables){
   float *tmp_table1=(float*)malloc(sizeof(float)*nsinc*ns);
  
   for(int i=0; i < ns; i++) memcpy((tmp_table1+nsinc*i),tables[i],nsinc*sizeof(float));

   cuda_call(cudaMalloc((void**) &sincstable,ns*nsinc*sizeof(float)));
   cuda_call(cudaMemcpy(sincstable, tmp_table1, ns*nsinc*sizeof(float),cudaMemcpyHostToDevice));

   cuda_call(cudaMemcpyToSymbol(sinc_s_table, &sincstable, sizeof(float*)));
   free(tmp_table1); //Might want to memcpytosymbol
   cuda_call(cudaMemcpyToSymbol(nsinc_gpu, &nsinc, sizeof(int)));
 }

void transfer_sinc_table_d(int nsinc,  int nd, float **tabled){
   float *tmp_table2=(float*)malloc(sizeof(float)*nsinc*nd);
   for(int i=0; i < nd; i++) memcpy((tmp_table2+nsinc*i),tabled[i],nsinc*sizeof(float));
   cuda_call(cudaMalloc((void**) &sincdtable,nd*nsinc*sizeof(float)));
   cuda_call(cudaMemcpy(sincdtable, tmp_table2, nd*nsinc*sizeof(float),cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpyToSymbol(sinc_d_table, &sincdtable, sizeof(float*)));
   free(tmp_table2);
}

void transfer_source_func(int npts, int nt, int *locs, float *vals){

  cuda_call(cudaMalloc((void**) &source_gpu,nt*npts*sizeof(float)));

  cuda_call(cudaMalloc((void**) &srcgeom_gpu,npts*sizeof(float)));
  cuda_call(cudaMemcpy(srcgeom_gpu, locs, npts*sizeof(float), cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpy(source_gpu, vals, nt*npts*sizeof(float), cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(ntrace_gpu, &nt, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(srcgeom_gpu0, &srcgeom_gpu, sizeof(float*)));
  cuda_call(cudaMemcpyToSymbol(source_gpu0, &source_gpu, sizeof(float*)));

 }

void transfer_receiver_func(int npts, int nt, int *locs, float *vals){
  fprintf(stderr,"  Transfer receiver function npts=%d nt=%d nt*npts=%d \n",npts,nt,nt*npts);
  cuda_call(cudaMalloc((void**) &data_gpu,nt*npts*sizeof(float)));
  cuda_call(cudaMalloc((void**) &datageom_gpu,npts*sizeof(float)));
  cuda_call(cudaMemcpy(datageom_gpu, locs, npts*sizeof(float),	 cudaMemcpyHostToDevice));
						
				int h=0;
  for(int i=0; i < npts; i++){
	if(locs[i]>1){
	 h++;
//	 fprintf(stderr,"   DATA GEOM %d %d %d\n",i,locs[i],h);
	}
	}
							
														 
  cuda_call(cudaMemcpy(data_gpu, vals, nt*npts*sizeof(float), cudaMemcpyHostToDevice));
														 
  cuda_call(cudaMemcpyToSymbol(nrec_gpu, &npts, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(ntrace_gpu, &nt, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(datageom_gpu0, &datageom_gpu, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(data_gpu0, &data_gpu, sizeof(int)));


 }

extern "C" __global__ void readTexels(int n, float *check_tex_d){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i<n){
	  float x = tex3D(vel_ref1,i,1,1);
	  check_tex_d[i] = i;
	}
}

void transfer_vel_func1(int nz, int nx, int ny, float *vel){

    cudaExtent const extv1 = {nz, nx, ny};
  
    cudaMemcpy3DParms cp1 = {0};
    cp1.srcPtr = make_cudaPitchedPtr((void*)vel, nz*sizeof(float), nx, ny);
    cp1.dstArray = vel_array1;
    cp1.extent = extv1;
    cp1.kind = cudaMemcpyHostToDevice; 
    cuda_call( cudaMemcpy3D(&cp1));

    cuda_call(cudaBindTextureToArray(vel_ref1, vel_array1));

}

void transfer_vel_func2(int nz, int nx, int ny, float *vel){
    cudaExtent const extv2 = {nz, nx, ny};

    cudaMemcpy3DParms cp2 = {0};
    cp2.srcPtr = make_cudaPitchedPtr((void*)vel, nz*sizeof(float), nx, ny);
    cp2.dstArray = vel_array2;
    cp2.extent = extv2;
    cp2.kind = cudaMemcpyHostToDevice;
    cuda_call( cudaMemcpy3D(&cp2));

    cuda_call(cudaBindTextureToArray(vel_ref2, vel_array2));

} 

void create_gpu_space(float d1, float d2, float d3, float bc_a, float bc_b, float bc_b_y, int nz, int nx, int ny){
    int n1=nz;
    int n2=nx;
    int n3=ny;

    cudaChannelFormatDesc cf1 = cudaCreateChannelDesc<float>();
    cudaExtent const extv1 = {n1, n2, n3};
    cuda_call(cudaMalloc3DArray(&vel_array1, &cf1, extv1));

    cudaChannelFormatDesc cf2 = cudaCreateChannelDesc<float>();
    cudaExtent const extv2 = {n1, n2, n3};
    cuda_call(cudaMalloc3DArray(&vel_array2, &cf2, extv2));

    cuda_call(cudaMemcpyToSymbol(n1gpu, &n1, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(n2gpu, &n2, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(n3gpu, &n3, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(bc_agpu, &bc_a, sizeof(float)));
    cuda_call(cudaMemcpyToSymbol(bc_bgpu, &bc_b, sizeof(float)));
    cuda_call(cudaMemcpyToSymbol(bc_b_ygpu, &bc_b_y, sizeof(float)));

    float coeffs_cpu[COEFFS_SIZE]=get_coeffs((double)d1,(double)d2,(double)d3);
    dd1=1./(double)d1/(double)d1;
    dd2=1./(double)d2/(double)d2;
    dd3=1./(double)d3/(double)d3;

    cuda_call(cudaMemcpyToSymbol(coeffs, coeffs_cpu, COEFFS_SIZE*sizeof(float), 0,cudaMemcpyHostToDevice));

}

