#include "map_data_3d.h"
#include "math.h"
 //   map_data mapit(npts,s_z,s_x,s_y,locs,   model=src_p0, dom=rec_func, ran=shot_deriv     ,nt_big);//s_y introduce
 
map_data::map_data(int npt,float *s_z,float *s_x,float *s_y, int *locs, hypercube_float *model,
  hypercube_float *dom, hypercube_float *ran,int ntbig){
  scale=new float[npt];
  map=locs;
  int h=0;
  ntb=ntbig;
  int ia=0;  
  int n1=model->get_axis(1).n;
  int n2=model->get_axis(2).n;

  for(int i4=0; i4 < npt; i4++){

    int ix=(int)s_x[i4];
    int iz=(int)s_z[i4];
    int iy=(int)s_y[i4];//add

    float sm=0;
      float yn=s_y[i4]-iy;
        float xn=s_x[i4]-ix;

          int ia=i4;
          float zn=s_z[i4]-iz;
          scale[ia]=expf(-zn*zn-xn*xn-yn*yn);
if(iz>0){
h++;
//fprintf(stderr,"mapping n1=%d n2=%d iz ix iy %d %d %d; npt=%d; zn yn xn %f %f %f sm %f tot %d \n",n1,n2,iz,ix,iy,npt,zn,xn,yn,sm,h);
}
          map[ia]=iz+ix*n1+iy*n1*n2;//add extra argument here and above
   //       sm+=scale[ia];
//fprintf(stderr,"THE MAP %d %d \n",ia,map[ia]);
  }

  set_domain(dom);
  set_range(ran);
}


 //   mapit.adjoint(false,  m=rec_func,  d=shot_deriv);

bool map_data::adjoint(bool add, my_vector *model, my_vector *data){
  float_3d *d=(float_3d*) data;
  float_3d *m=(float_3d*) model;
  if(!add) m->zero();
  int nt=d->get_axis(1).n;
  int n2=d->get_axis(2).n;
  int n3=d->get_axis(3).n;//add this
  int ibig=0,ia=0;
  fprintf(stderr,"Mapping adjoint nt=%d n2=%d n3=%d, ntb=%d \n",nt,n2,n3,ntb);
  for(int i3=0; i3 < n3; i3++){ //add in this loop too
    for(int i2=0; i2 < n2; i2++){
//ia=1;
        for(int it=0; it < nt; it++,ibig++){
          m->vals[ntb*i2+it+4+i3*ntb*n2]+=d->vals[it+i2*nt+i3*nt*n2]*scale[ia];//add extra arg
//          m->vals[it+i2*nt+i3*nt*n2]+=d->vals[it+i2*nt+i3*nt*n2]*scale[ia];//add extra arg
//        }
      }
    }
  }
}
bool map_data::forward(bool add, my_vector *model, my_vector *data){
  float_3d *d=(float_3d*) data;
  float_3d *m=(float_3d*) model;
  axis a1=d->get_axis(1);
  axis a2=d->get_axis(2);
  axis a3=d->get_axis(3);
  int nt=d->get_axis(1).n;
  int n2=d->get_axis(2).n;
  int n3=d->get_axis(3).n;
  float tt=0;
  int ibig=0,ia=0;
  if(!add) d->zero();
    for(int i3=0; i3 < n3; i3++){//include this loop, and the other sections pertaining to it
      for(int i2=0; i2 < n2; i2++){
        for(int i1=0; i1 < 36; i1++,ia++){
          for(int it=0; it < nt; it++,ibig++){
            d->vals[it+i2*nt+i3*nt*n2]+=m->vals[ntb*ia+it+4]*scale[ia];
        }
      }
    }
  } 

}

