#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_fd_2d.h>
#include <data_rtm_2d.h>
#include <image_rtm_2d.h>
#include "wavelet_rtm.h"
#include "acoustic_model_2d_damp.h"
#include "acoustic_model_2d_rand.h"

 main(int argc, char **argv){

   sep_params pars=sep_params(argc,argv);
   data_rtm_2d data=data_rtm_2d("data");
   float *buf,*guf;
   
   wavelet_rtm wavelet=wavelet_rtm("wavelet");
   
   vel_fd_2d vel=vel_fd_2d("velocity"); 
   image_rtm_2d image=image_rtm_2d("image",&vel);
    
   float range_x=pars.get_float("range_x",12.);

   axis v1=vel.fld->get_axis(1);
   axis v2=vel.fld->get_axis(2);
   guf=new float[v1.n*v2.n];
   buf=new float[v1.n*v2.n*data.nt];
   for(int i=0; i < v1.n*v2.n; i++) guf[i]=0;

   float *ig=new float[v1.n*v2.n];
     for(int i=0; i < v1.n*v2.n; i++) ig[i]=0;
   for(int ishots=0; ishots < data.nshots(); ishots++){


     float sz,sx;
     
     fprintf(stderr,"WORKING ON %d of %d \n",ishots,data.nshots());
     data.set_shot_num(ishots);
     data.load_shot();
     data.get_shot_loc(&sx,&sz);

     int b2=MAX(0,MIN(v2.n-1,floor(((sx-range_x)-v2.o)/v2.d+.5)));
     int e2=MAX(0,MIN(v2.n-1,floor(((sx+range_x)-v2.o)/v2.d+.5)));
     b2=0; 
     e2=v2.n-1;
     wavelet.set_source_loc(sx,sz);
     acoustic_model_2d_damp shot_mod=acoustic_model_2d_damp(&vel,b2,e2); //shot be doing windowing

     shot_mod.set_source_function(&wavelet);
     shot_mod.set_initial_time(0.);
     acoustic_model_2d_damp rec_mod=acoustic_model_2d_damp(&vel,b2,e2);
     rec_mod.set_source_function(&data);
     rec_mod.set_initial_time(data.max_time);
     for(int it=0; it < data.nt; it++){
       rec_mod.propogate_shot(-data.dt,true);
       memcpy((buf+v1.n*v2.n*it),rec_mod.pp,4*v1.n*shot_mod.nx);
     }

     float time=data.max_time;
     for(int it=data.nt-1; it>=0 ;it--){
       shot_mod.propogate_shot(data.dt,true);
       for(int i=0; i < v1.n*v2.n; i++) ig[i+b2*v1.n ]+=shot_mod.pp[i]*buf[i+it*v1.n*v2.n];
       if(it%10==0)  {
         srite("src",shot_mod.pp,v1.n*rec_mod.nx*4);
         srite("rec",&buf[it*v1.n*v2.n],v1.n*v2.n*4);
         srite("image",ig,v1.n*v2.n*4);
       }
     }
  }
 
   
   return 0;
 }
       






