#include "rtm_zero_op_3d.h"
#include "sinc_bob.h"
#include "gpu_funcs_3d_rec.h"
#include <math.h>
#include "deriv_3d.h"
#include "map_data_3d.h"
rtm_zero_op::rtm_zero_op(param_func *par,vel_fd_3d *vel_3d, source_func *source_func, data_rtm_3d *dat, image_rtm_3d *img,float ap,bool v,bool do_src,bool redo_src){
   if(redo_src) fprintf(stderr,"UEP \n");
      if(do_src) fprintf(stderr,"dUEP \n");
   std::vector<float> ds; 
   data=dat;
   ds.push_back(dat->dt);
   ds.push_back(source_func->get_dt());
   set_vel(vel_3d);
   calc_stability(&ds,data->nt);
   set_fd_basics(par,source_func,ap,v);
   image=img;
   set_domain(image);
   set_range(data);
   dtd=data->dt;
   jtd=(int)(dtd/dt);
   nt=(data->nt-1)*jtd+1;
// nt=850;
   base=0;
   redo=redo_src;
   create_transfer_sinc_data(8);
   std::cout<<"Redo is "<<redo<<" "<<redo_src<<std::endl;


   if(do_src && !redo) create_source_fields();
 //    if(do_src && !redo) create_source_fields_incore();

 
}
void rtm_zero_op::create_transfer_sinc_data(int nsinc){
  jtd=(int)((data->dt)/dt);
  sinc_bob myr(jtd,nsinc);
  transfer_sinc_table_d(nsinc,jtd,myr.table);
}

   
void rtm_zero_op::create_source_fields(){

  int nshots=data->nshots();
  auxinout("source_fields");  
//      slice_p0=(float*) calloc (nz*nx*ny,sizeof(float));

  int npts,nt_big;
  nt_big=9+data->nt; //1 more because we continue to nt+1
  npts=source->get_points();//this is just=9
  int *locs=new int[npts];
  float *vals=new float[npts*(nt_big)];
  int *tempi=0;
  float *tempf=0;
nshots=1;
  for(int ishot=0; ishot< nshots; ishot++){
     if(verb) fprintf(stderr,"Forward propagating shot %d of %d \n",ishot,nshots);
     hypercube_float *src_p0=source->create_domain(ishot);
     hypercube_float *src_p1=src_p0->clone();
     hypercube_float *vloc=vel->rand_subspace(ishot+base,nboundt,nbound,nbound,dt,src_p0);

     source->get_source_func(src_p0,ishot,nt_big,locs,vals);
     transfer_source_func(npts,nt_big,locs,vals);

     transfer_vel_func1(nz,nx,ny,vloc->vals);//first change goes here
fprintf(stderr,"Vel dims! %d %d %d, others %d %d %d %f , time+2 %d\n",nz,nx,ny,ishot+base,nboundt,nbound,dt,nt+2);
     hypercube_float *vnone=vel->rand_subspace(ishot+base,0,0,0,dt,src_p0);//add the new argument to here
     transfer_vel_func2(nz,nx,ny,vnone->vals);//ny here
float *temp=0;
//     float *temp=new float[nx*ny*157];
     source_prop(nz,nx,ny,false,true,src_p0->vals,src_p1->vals,temp,jts,npts,nt,0,tempi,tempf,-1,"junk");//bring back!!
srite("velout",vloc->vals,4*nz*nx*ny);
     srite("source_fields",src_p0->vals,nz*nx*ny*4);//change sizes
     srite("source_fields",src_p1->vals,nz*nx*ny*4);

//     srite("shot_out",temp,nx*ny*4*157);

     delete vloc;
   }
   delete [] locs;
   delete [] vals;
}

bool rtm_zero_op::forward(bool add, my_vector *mvec, my_vector *dvec){
  data_rtm_3d *d=(data_rtm_3d*) dvec;
  image_rtm_3d *m=(image_rtm_3d*) mvec;
fprintf(stderr,"   rtm_zero_op::bool fwd \n");
   if(!add) {
     dvec->zero();     
     }
  int npts_s=source->get_points();
   //data=d;
  //  image=m;
  data->set_source_file(d);
  image->set_source_file(m);

  int nt_big=8+data->nt;

  int npts=data->get_points();
  int *locs=new int[npts];

  int *locs_s=new int[npts_s];
  float *vals=new float[npts_s*(nt_big)];
  float *s_z=new float[npts/9],*s_x=new float[npts/9],*s_y=new float[npts/9];//add s_y here

  axis ax_pt(npts);//is this just for 2d???
  float_3d *shot=new float_3d(data->get_axis(1),data->get_axis(2),data->get_axis(3));
  float_3d *shot_deriv=new float_3d(data->get_axis(1),data->get_axis(2),data->get_axis(3));//made these both 3d

  axis ax_t=axis(nt_big);
//  float_3d *rec_func=new float_3d(ax_t,ax_pt,ax_pt);//want to check on this
  sseek("source_fields",0,0);
  int nshots=data->nshots();
  
  int nts=(int)(nt/jts)+1;
  float *wave_cpu=new float[nts*nx*nz*ny]; //make bigger
  
  for(int ishot=0; ishot<nshots; ishot++){

    if(verb) fprintf(stderr,"Forward shot %d of %d \n",ishot,data->nshots());
    hypercube_float *src_p0=source->create_domain(ishot);
    hypercube_float *src_p1=src_p0->clone();
    axis ad1=src_p0->get_axis(1);
    axis ad2=src_p0->get_axis(2);
    axis ad3=src_p0->get_axis(3);//added ad3

    hypercube_float *vrand=vel->rand_subspace(ishot+base,nboundt,nbound,nbound,dt,src_p0);//add second rand depth for y
    hypercube_float *vnone=vel->rand_subspace(ishot+base,0,0,0,dt,src_p0);//and here
    hypercube_float *img=image->extract_sub(ad1,ad2,ad3);//ad3 to here
    transfer_vel_func1(nz,nx,ny,vrand->vals);
    transfer_vel_func2(nz,nx,ny,vnone->vals);//ny to these
    source->get_source_func(src_p0,ishot,nt_big,locs_s,vals);
    transfer_source_func(npts_s,nt_big,locs_s,vals); //think these are ok  


    data->get_source_func(src_p0,ishot,s_z,s_x,s_y,8,nt_big,shot);//s_y here....is it ready?
 //   map_data mapit(npts,s_z,s_x,s_y,locs,src_p0,rec_func,shot_deriv,nt_big);//and here???
    sreed("source_fields",wave_cpu,nz*nx*ny*nts*4);

 //   transfer_receiver_func(npts,nt_big,locs,rec_func->vals);
 //   fprintf(stderr,"CHECK SIZE %lld \n",rec_func->get_n123());
//    rtm_forward2(ad1.n,ad2.n,jtd,img->vals,rec_func->vals,npts_s,npts,nt,nt_big,npts, //this wasnt commented before, but it wasnt doing anything
//      wave_cpu);
     //     rtm_forward(ad1.n,ad2.n,jtd,img->vals,rec_func->vals,npts_s,npts,nt,nt_big,npts
     //);
      

    deriv der=deriv(shot_deriv,shot);
  //  mapit.forward(false,rec_func,shot_deriv);
    der.forward(false,shot_deriv,shot);
    data->add_data(ishot,shot);   
fprintf(stderr,"add data pt");
    delete src_p0; delete src_p1; delete img;
    delete vrand; delete vnone;
  }
  fprintf(stderr,"DID FORWARD %s %s \n",d->tagit.c_str(),m->tagit.c_str()); 
  delete [] s_z;
  delete [] s_x;
  delete [] s_y;
  delete [] locs_s; delete [] vals;
  delete [] wave_cpu;
  return true;
  

 
}

bool rtm_zero_op::adjoint(bool add, my_vector *mvec, my_vector *dvec){
if(1==3){
 if(!check_domain_range(mvec,dvec)) {
    fprintf(stderr,"rtm_zero_op failed \n");
    return false;
  }
  }

  if(redo){
     base+=1000;
     create_source_fields();
  }
   if(!add) mvec->zero();

  data_rtm_3d *d=(data_rtm_3d*) dvec;
  image_rtm_3d *m=(image_rtm_3d*) mvec;
  int npts_s=source->get_points();
  data->set_source_file(d);

  image->set_source_file(m);
  int nt_big=8+data->nt;
  int npts=data->get_points();
  int npts1=data->get_points1();//just 2nd axis
  int npts2=data->get_points2();//just 3rd axis


  int *locs=new int[npts];
  int *locs_s=new int[npts_s];
  float *vals=new float[npts_s*(nt_big)];

  //float *vals=new float[npts*nt_big];
  float *s_z=new float[npts],*s_x=new float[npts],*s_y=new float[npts];//add s_y
  axis ax_pt1(npts1);
  axis ax_pt2(npts2);
fprintf(stderr,"Locs details npts=%d npts_s=%d vals=%d\n",npts,npts_s,npts_s*nt_big);

  float_3d *shot=new float_3d(data->get_axis(1),data->get_axis(2),data->get_axis(3));
  float_3d *shot_deriv=new float_3d(data->get_axis(1),data->get_axis(2),data->get_axis(3));//these both 3D
  axis ax_t=axis(nt_big);

  float_3d *rec_func=new float_3d(ax_t,ax_pt1,ax_pt2);//this is NOT RIGHT


  sseek("source_fields",0,0);
  image->zero();
  int nts=(int)(nt/jts)+1;
//  float *wave_cpu=new float[nts*nx*nz*ny];//made bigger

  int nshots=data->nshots();
nshots=1;
  for(int ishot=0; ishot<nshots; ishot++){
   /* if(verb)*/ fprintf(stderr,"Adjoint shot %d of %d \n",ishot,data->nshots());
    hypercube_float *src_p0=source->create_domain(ishot);
    hypercube_float *src_p1=src_p0->clone();
    axis ad1=src_p0->get_axis(1);
    axis ad2=src_p0->get_axis(2);
    axis ad3=src_p0->get_axis(3);//this guy added
    hypercube_float *vrand=vel->rand_subspace(ishot+base,nboundt,nbound,nbound,dt,src_p0);//new y pad installed
    hypercube_float *vnone=vel->rand_subspace(ishot+base,0,0,0,dt,src_p0);//as above
    hypercube_float *img=src_p0->clone();
    transfer_vel_func1(nz,nx,ny,vrand->vals);
    transfer_vel_func2(nz,nx,ny,vnone->vals);//mr ny included
    data->get_source_func(src_p0,ishot,s_z,s_x,s_y,8,nt_big,shot);//s_y came along

    deriv der=deriv(shot_deriv,shot);

    der.adjoint(false,shot_deriv,shot);

    map_data mapit(npts,s_z,s_x,s_y,locs,src_p0,rec_func,shot_deriv,nt_big);//s_y introduce
//srite("dcheck",shot->vals,1024*ax_pt1.n*ax_pt2.n*4);

fprintf(stderr," Rec func size %d %d %d total=%d\n",ax_t.n,ax_pt1.n,ax_pt2.n,ax_t.n*ax_pt1.n*ax_pt2.n);
fprintf(stderr," Shot size %d %d %d \n",data->get_axis(1).n,data->get_axis(2).n,data->get_axis(3).n);

    mapit.adjoint(false,rec_func,shot_deriv);

srite("dcheck",shot->vals,data->get_axis(1).n*data->get_axis(2).n*data->get_axis(3).n*4);


fprintf(stderr,"Dims for source fields %d %d %d \n",ad1.n,ad2.n,ad3.n);
      sreed("source_fields",src_p1->vals,4*ad1.n*ad2.n*ad3.n);
      sreed("source_fields",src_p0->vals,4*ad1.n*ad2.n*ad3.n);//incorporated y

    transfer_receiver_func(npts,nt_big,locs,rec_func->vals);

srite("dcheck",rec_func->vals,ax_t.n*ax_pt1.n*ax_pt2.n*4);

    source->get_source_func(src_p0,ishot,nt_big,locs_s,vals);
    //int i=0;


   transfer_source_func(npts_s,nt_big,locs_s,vals);    
     float *temp2=new float[27*264*216*216];
   rtm_adjoint(ad1.n,ad2.n,ad3.n,jtd,src_p0->vals,src_p1->vals,temp2,npts_s,npts,nt);//ad3.n here
     srite("check",temp2,27*264*216*216*4);

  // rtm_adjoint(ad1.n,ad2.n,ad3.n,jtd,src_p0->vals,src_p1->vals,img->vals,npts_s,npts,nt);//ad3.n here
  //  rtm_adjoint2(ad1.n,ad2.n,jtd,img->vals,wave_cpu,npts_s,npts,nt);
    image->add_image(img);

    delete src_p0; delete src_p1; delete img;
    delete vrand; delete vnone;
  }
  fprintf(stderr,"DID ADJOINT %s %s \n",d->tagit.c_str(),m->tagit.c_str()); 
//  delete [] wave_cpu;
  image->write_volume();

  delete [] s_z;
  delete [] s_x;
  delete [] s_y;//this wasnt here before!
  delete [] locs_s; delete [] vals;

  return true;
}
