#include "source_func_3d.h"
#include<math.h>

source_func::source_func(char *tag){
   tag_init(tag);
   hypercube_float *tmp=new hypercube_float(this);
   wavelet=new hypercube_float(this);
   read_all(tag,tmp);
   wavelet->vals[get_axis(1).n-1]=0;
   for(int it=0; it < this->get_axis(1).n-1; it++) {
     wavelet->vals[it]=(tmp->vals[it+1]-tmp->vals[it])/tmp->get_axis(1).d;
  //fprintf(stderr,"IT %d %f %d \n",it,wavelet->vals[it],get_axis(1).n);
}
   delete tmp;
   dt=get_axis(1).d;
   
}

//Here, for now assume sources in a rectangular grid
void source_func::set_sources_3d(float s_z, axis src_axis1, axis src_axis2){
fprintf(stderr,"Setting sources nsx=%d nsy=%d %d\n",src_axis1.n,src_axis2.n,get_axis(1).n);
  for(int i2=0; i2 < src_axis2.n; i2++){
    for(int i1=0; i1 < src_axis1.n; i1++){
      sz.push_back(s_z);
      sx.push_back(src_axis1.o+src_axis1.d*i1);
      sy.push_back(src_axis2.o+src_axis2.d*i2);
 //     fprintf(stderr,"src stuff 1 %f %f %f\n",s_z,src_axis1.o+src_axis1.d*i1,src_axis2.o+src_axis2.d*i2);
    }
  }
}

int source_func::get_points( ){

 return 9;
// return 36;

}
void source_func::set_compute_size(hypercube *dom, float ap,int nbt, int nb, int nby, int fat,
  int blocksize){
  az=dom->get_axis(1);
  ax=dom->get_axis(2);
  ay=dom->get_axis(3);
  nbound=nb+fat; nboundt=nbt; nbound_y=nby+fat;
  aper=ap;
  ay.n=(int)(ap/ay.d)*2+1+2*nbound_y;
  ax.n=(int)(ap/ax.d)*2+1+2*nbound;
  az.n=az.n+nbt+nb+fat*2;

  int t1=(ax.n-fat*2)/blocksize;
  int rem=ax.n-t1*blocksize-2*fat;
  if(rem!=0) rem=blocksize-rem;
  if(rem!=0) ax.n+=+rem;

  t1=(ay.n-fat*2)/blocksize;
  rem=ay.n-t1*blocksize-2*fat;
  if(rem!=0) rem=blocksize-rem;
  if(rem!=0) ay.n+=+rem;
    
  t1=(az.n-fat*2)/blocksize;
  rem=az.n-t1*blocksize-2*fat;
  if(rem!=0) rem=blocksize-rem;
  if(rem!=0) az.n+=+rem;

  az.o=az.o-(nbt+fat)*az.d;
  
}
//hypercube_float *source_func::create_domain(int ishotx, int ishoty){
hypercube_float *source_func::create_domain(int ishot){

  // fprintf(stderr,"source_func - create_domain %d %d %d %d\n",get_axis(1).n,az.n,ax.n,ay.n);

  ax.o=sx[ishot]-aper-ax.d*nbound;
  ay.o=sy[ishot]-aper-ay.d*nbound; // need to think more about this!!
  std::vector<axis>  axes; axes.push_back(az); axes.push_back(ax); axes.push_back(ay);
  hypercube_float *tmp=new hypercube_float(axes);
fprintf(stderr,"Creating source domain %f %f %f %f %d %d\n",ax.o,sx[ishot],aper,ax.d,nbound,ax.n);
  return tmp; 
}

void source_func::get_source_func(hypercube_float *domain, int ishot, int nts,
int *locs, float *time){
  axis a1=domain->get_axis(1);
  axis a2=domain->get_axis(2);
  axis a3=domain->get_axis(3);
  axis at=get_axis(1);
  float fy=(sy[ishot]-a3.o)/a3.d;
  float fx=(sx[ishot]-a2.o)/a2.d;
  float fz=(sz[ishot]-a1.o)/a1.d;
  int iy=(int)fy;
  int ix=(int)fx;
  int iz=(int)fz;
  int i=0;
fprintf(stderr,"  Shot set up, %f %f %f ; %f %f %f ; %d %d %d \n",sz[ishot],sx[ishot],sy[ishot],a1.o,a2.o,a3.o,iz,ix,iy);
//fprintf(stderr,"i dont think locations are being made... %f %f %f %d %d %d %d %d\n",fy,fx,fz,iy,ix,iz,at.n,nts);
//simply add y into this loop...
  for(int it=0; it < nts*9; it++){//was 9
    time[it]=0;
  }
    for(int i3=iy-1; i3 <= iy-1; i3++){
    float yn=fy-i3;
      for(int i2=ix-1; i2 <= ix+1; i2++){
      float xn=fx-i2;
      for(int i1=iz-1; i1<= iz+1; i1++,i++){
        float zn=fz-i1;
        locs[i]=i1+i2*a1.n+i3*a1.n*a2.n;
        float scale=expf(-zn*zn-xn*xn-yn*yn);
//fprintf(stderr,"locs in src %d %f %f %f %d \n",locs[i],sz[ishot],sx[ishot],sy[ishot],i);
//fprintf(stderr,"check on i %d\n",i);
//fprintf(stderr,"let's see here %d %d %d %d %d\n",i,i1,i2,i3,nts*i+4);
        for(int it=0; it < at.n; it++){
          time[nts*i+it+4]=scale*wavelet->vals[it];
 //         fprintf(stderr,"THE SOURCE FUNCTION %d %d %d %d %d %d %f %f\n",i,it,i1,i2,i3,nts*i+it+4,time[nts*i+it+4],scale*wavelet->vals[it]);
        }
      }
    } 
  }
}


